"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

RBFormatter subclass:#TFormatter
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-AST'
!

!TFormatter methodsFor:'visitor-double dispatching'!

acceptSimpleTypeNode: aTSimpleTypeNode
    codeStream nextPutAll: aTSimpleTypeNode name

    "Created: / 21-08-2015 / 22:20:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

acceptTypeSpecNode: aTTypeSpecNode
    codeStream nextPut:$<; space.
    self visitNode: aTTypeSpecNode type.
    codeStream space; nextPut:$>.

    "Created: / 21-08-2015 / 22:18:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

acceptUnionTypeNode: aTUnionTypeNode
    aTUnionTypeNode types do:[:type | 
        self visitNode: type
    ] separatedBy:[ 
        codeStream space; nextPut: $|; space
    ].

    "Created: / 21-08-2015 / 22:21:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

