"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

RBMethod subclass:#TMethod
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-Model'
!

!TMethod methodsFor:'accessing'!

method
    "Returns Method instance which is present or retrived from real class"

    ^ nil "/ For Tea, there are no real methods (yet).
          "/ Later it may return Tea host method."

    "Created: / 25-08-2015 / 19:10:11 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

method: aCompiledMethod 
    self shouldNeverBeSent

    "Created: / 25-08-2015 / 19:09:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

parseTree
    ^ TParser parseMethod: self source

    "Created: / 25-08-2015 / 19:43:51 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

selector
    selector isNil ifTrue:[ 
        selector := self parseTree selector.
    ].
    ^ selector

    "Created: / 25-08-2015 / 19:48:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

source
    ^ source

    "Created: / 25-08-2015 / 19:44:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

