"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

TTypeNode subclass:#TSimpleTypeNode
	instanceVariableNames:'name start stop'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-AST'
!

!TSimpleTypeNode methodsFor:'accessing'!

name
    ^ name
!

name:aString
    name := aString.
!

start
    ^ start
!

start:anInteger
    start := anInteger.
!

stop
    ^ stop
!

stop:anInteger
    stop := anInteger.
! !

!TSimpleTypeNode methodsFor:'conversion'!

asType
    "superclass TTypeNode says that I am responsible to implement this method"

    ^ TSimpleType named: name

    "Modified: / 25-08-2015 / 23:04:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TSimpleTypeNode methodsFor:'visitor'!

acceptVisitor: aProgramNodeVisitor 
    ^ aProgramNodeVisitor acceptSimpleTypeNode: self

    "Created: / 21-08-2015 / 22:15:13 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

