"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

Object subclass:#TType
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-Types'
!


!TType methodsFor:'comparing'!

= anotherType
    ^ self subclassResponsibility

    "Created: / 25-08-2015 / 23:34:29 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

hash
    ^ self subclassResponsibility

    "Created: / 25-08-2015 / 23:33:59 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TType methodsFor:'operations'!

union: aTType
    TUnionType with: self with: aTType

    "Created: / 21-08-2015 / 18:36:18 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TType methodsFor:'printing & storing'!

printOn:aStream
    aStream nextPut: $<; space.
    self printWithoutAnglesOn:aStream.
    aStream nextPut: $>; space.

    "Modified: / 21-08-2015 / 13:46:25 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

printWithoutAnglesOn:aStream
    self subclassResponsibility

    "Created: / 21-08-2015 / 13:46:43 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TType methodsFor:'testing'!

isSimpleType
    ^ false
!

isUnionType
    ^ false
! !

!TType class methodsFor:'documentation'!

version
    ^ 'Path: jv/tea/compiler/TType.st, Version: 1.0, User: jv, Time: 2015-08-26T07:46:38.380+01'
!

version_HG
    ^ 'Path: jv/tea/compiler/TType.st, Version: 1.0, User: jv, Time: 2015-08-26T07:46:38.380+01'
! !

