"{ Package: 'jv:tea/compiler' }"

"{ NameSpace: Smalltalk }"

RBProgramNode subclass:#TTypeNode
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Tea-Compiler-AST'
!

!TTypeNode class methodsFor:'accessing'!

formatterClass
    ^ FormatterClass isNil ifTrue: [TFormatter] ifFalse: [FormatterClass]

    "Created: / 21-08-2015 / 22:16:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!TTypeNode class methodsFor:'queries'!

isAbstract
    "Return if this class is an abstract class.
     True is returned here for myself only; false for subclasses.
     Abstract subclasses must redefine again."

    ^ self == TTypeNode.
! !

!TTypeNode methodsFor:'conversion'!

asType
    ^ self subclassResponsibility

    "Created: / 25-08-2015 / 22:47:26 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

